<?php
use CRM_Loginsecurity_ExtensionUtil as E;

class CRM_Loginsecurity_Page_LoginSecurityHistory extends CRM_Core_Page {

  public function run() {
    CRM_Utils_System::setTitle(E::ts('Access History'));

    $contact_id = CRM_Core_Session::getLoggedInContactID();

    $result = \Civi\Api4\LoginSecurityDevice::get(FALSE)
      ->addWhere('contact_id', '=', $contact_id)
      ->addOrderBy('last_seen', 'DESC')
      ->setLimit(50)
      ->execute();

    $history = [];
    $has_country = false;

    foreach ($result as $record) {
      $record['geoip'] = CRM_Loginsecurity_BAO_LoginSecurityDevice::getGeoIP($record['ip_address'] ?? '');

      if (!empty($record['geoip'])) {
        $has_country = true;
      }

      $history[] = $record;
    }

    $this->assign('loginSecurityDevices', $history);
    $this->assign('loginSecurityHasCountry', $has_country);

    parent::run();
  }

}
